//************** snake sound **********************

snake_sound_eat_abc:
	db "L: 1/16" 0x0a
	db "C,G,'" 0

snake_sound_eat_fungus_abc:
	db "L: 1/16" 0x0a
	db "A,," 0

snake_sound_eat_glass_abc:
	db "L: 1/100" 0x0a
	db "d'e'd'" 0

snake_sound_hit_hedge_abc:
	db "L: 1/100" 0x0a
	db "^B,," 0

snake_sound_hit_stone_abc:
	db "L: 1/100" 0x0a
	db "^C," 0

snake_sound_hit_snake_abc:
	db "L: 1/100" 0x0a
	db "^d''b' " 0

snake_sound_eat:
	PUSH HL
	PUSH DE
	PUSH BC
	PUSH AF
	LD HL,snake_sound_eat_abc:
	CALL sound_parser_abc:
	POP AF
	POP DE
	POP BC
	POP HL
	RET

snake_sound_eat_fungus:
	PUSH HL
	PUSH DE
	PUSH BC
	PUSH AF
	LD HL,snake_sound_eat_fungus_abc:
	CALL sound_parser_abc:
	POP AF
	POP BC
	POP DE
	POP HL
	RET

snake_sound_eat_glass:
	PUSH HL
	PUSH DE
	PUSH BC
	PUSH AF
	LD HL,snake_sound_eat_glass_abc:
	CALL sound_parser_abc:
	POP AF
	POP BC
	POP DE
	POP HL
	RET

snake_sound_hit_hedge:
	PUSH HL
	PUSH DE
	PUSH BC
	PUSH AF
	LD HL,snake_sound_hit_hedge_abc:
	CALL sound_parser_abc:
	POP AF
	POP BC
	POP DE
	POP HL
	RET

snake_sound_hit_stone:
	PUSH HL
	PUSH DE
	PUSH BC
	PUSH AF
	LD HL,snake_sound_hit_stone_abc:
	CALL sound_parser_abc:
	POP AF
	POP BC
	POP DE
	POP HL
	RET

snake_sound_hit_snake:
	PUSH HL
	PUSH DE
	PUSH BC
	PUSH AF
	LD HL,snake_sound_hit_snake_abc:
	CALL sound_parser_abc:
	POP AF
	POP BC
	POP DE
	POP HL
	RET

snake_sound_crawl:
	// is the sound queue empty?
	IN A,(5)
	OR A,A
	RET Z
	// initialize sound
	XOR A,A
	OUT (5),A
	LD A,127
	OUT (2),A // loudness
	LD A,1
	OUT (3),A // length
	LD A,64
	OUT (4),A // length-unit
	LD A,100
	OUT (6),A // bpm
	LD B,5
snake_sound_crawl_loop:
	IN A,(1)
	AND A,31
	ADD A,96
	OUT (5),A
	DEC B
	JR NZ snake_sound_crawl_loop:
	RET

snake_sound_title:
	PUSH HL
	PUSH DE
	PUSH BC
	PUSH AF
	LD A,2
	OUT (3),A
	LD A,1
	OUT (4),A
	OUT (5),A
	LD HL,tunes_coisish_abc:
	CALL sound_parser_abc:
	LD HL,tunes_coisish_abc:
	CALL sound_parser_abc:
	LD HL,tunes_aRuin_abc:
	CALL sound_parser_abc:
	LD HL,tunes_aRuin_abc:
	CALL sound_parser_abc:
	LD HL,tunes_aRuin_abc:
	CALL sound_parser_abc:
	POP AF
	POP BC
	POP DE
	POP HL
	RET

snake_sound_gameOver:
	PUSH HL
	PUSH DE
	PUSH BC
	PUSH AF
	LD A,1
	OUT (3),A
	LD A,1
	OUT (4),A
	OUT (5),A
	LD HL,tunes_stivel_abc:
	CALL sound_parser_abc:
	POP AF
	POP BC
	POP DE
	POP HL
	RET

snake_sound_winner:
	PUSH HL
	PUSH DE
	PUSH BC
	PUSH AF
	LD A,1
	OUT (3),A
	LD A,1
	OUT (4),A
	OUT (5),A
	LD HL,tunes_johnny_abc:
	CALL sound_parser_abc:
	LD HL,tunes_johnny_abc:
	CALL sound_parser_abc:
	LD HL,tunes_johnny_abc:
	CALL sound_parser_abc:
	POP AF
	POP BC
	POP DE
	POP HL
	RET

snake_sound_stop:
	PUSH AF
	XOR A,A
	OUT (5),A
	POP AF
	RET
	